function varargout = RFProcessing_details(varargin)
% RFPROCESSING_DETAILS M-file for RFProcessing_details.fig
%      RFPROCESSING_DETAILS, by itself, creates a new RFPROCESSING_DETAILS or raises the existing
%      singleton*.
%
%      H = RFPROCESSING_DETAILS returns the handle to a new RFPROCESSING_DETAILS or the handle to
%      the existing singleton*.
%
%      RFPROCESSING_DETAILS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RFPROCESSING_DETAILS.M with the given input arguments.
%
%      RFPROCESSING_DETAILS('Property','Value',...) creates a new RFPROCESSING_DETAILS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before RFProcessing_details_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to RFProcessing_details_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help RFProcessing_details

% Last Modified by GUIDE v2.5 11-Jan-2010 17:51:02

% Copyright (c) 2010 
% Andre Dau, Athanasios Karamalis, Christian Wachinger 
% Computer Aided Medical Procedures (CAMP) 
% Technische Universitt Mnchen (TUM) 
% http://campar.in.tum.de/Students/RFtoB 
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions are met:
%    * Redistributions of source code must retain the above copyright
%       notice, this list of conditions and the following disclaimer.
%    * Redistributions in binary form must reproduce the above copyright
%       notice, this list of conditions and the following disclaimer in the
%       documentation and/or other materials provided with the distribution.
%    * Neither the name of CAMP, TUM nor the
%       names of its contributors may be used to endorse or promote products
%       derived from this software without specific prior written permission.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% DISCLAIMED. IN NO EVENT SHALL Andre Dau, Athanasios Karamalis, Christian Wachinger BE LIABLE FOR ANY
% DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
% (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
% ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
% SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @RFProcessing_details_OpeningFcn, ...
                   'gui_OutputFcn',  @RFProcessing_details_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before RFProcessing_details is made visible.
function RFProcessing_details_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to RFProcessing_details (see VARARGIN)

% Choose default command line output for RFProcessing_details
handles.output = hObject;

%handles.infos stores the handle of the main figure
handles.infos = varargin{1};

%Display RF and transducer information
set(handles.text_speedOfSound,'String',handles.infos.speedOfSound);
set(handles.text_radius,'String',handles.infos.transducer_radius);
set(handles.text_pitch ,'String', handles.infos.transducer_pitch);
set(handles.text_phElements ,'String', handles.infos.transducer_number_of_elements);
set(handles.text_probeAngle ,'String', handles.infos.transducer_angle/pi*180);
set(handles.text_filetype ,'String', handles.infos.rfHdr.filetype);
set(handles.text_depth ,'String', handles.infos.rfDepth);
set(handles.text_frames , 'String',handles.infos.rfHdr.nframes);
set(handles.text_sectorSize ,'String', handles.infos.rfSectorSize);
set(handles.text_sectorAngle ,'String',handles.infos.rfSectorAngle/pi*180);
set(handles.text_scanlines ,'String', handles.infos.rfNumberOfScanlines);
set(handles.text_samples ,'String', handles.infos.rfNumberOfSamples);
set(handles.text_sampleSize , 'String',handles.infos.rfHdr.ss);
set(handles.text_probeId ,'String', handles.infos.rfHdr.probe);
set(handles.text_txFreq ,'String', handles.infos.rfHdr.txf/1000000);
set(handles.text_sFreq , 'String',handles.infos.rfHdr.sf/1000000);
set(handles.text_dataRate ,'String', handles.infos.rfHdr.dr);
set(handles.text_lineDensity ,'String', handles.infos.rfLineDensity);

%axes1 contains the raw rf image
pos = get(handles.axes1,'Position');
%resize to fit image ratio
figPos = get(gcf,'Position');
ratio = handles.infos.rfRatio;
width = min(pos(3)*figPos(3),pos(4)*figPos(4)*ratio)/figPos(3);
height = min(pos(4)*figPos(4),pos(3)*figPos(3)/ratio)/figPos(4);
set(handles.axes1,'Position',[pos(1:2) width height]);
axes(handles.axes1);
colormap(gray);
%basic envelope detection and log rescale in order to make rf data visible
imagesc(log(abs(hilbert(handles.infos.images{7}))*0.1+1),'Parent',handles.axes1);
axis off;

%calculate frequency spectrums
%stores all frequency spectrums
handles.fftFct = [];
%stores the average frequency spectrum
handles.fftFctGes = [];
%number of points for fft; fft is faster, if the number of points is a
%power of two
nfft = 2^nextpow2(handles.infos.rfNumberOfSamples);
for x = 1:size(handles.infos.images{7},2)
    %get a single rf line of the first frame
    line = handles.infos.images{7}(:,x,1);
    
    %calculate fft and rescale
    y = fft(line,nfft)/handles.infos.rfNumberOfSamples;
    
    %store the spectrum
    handles.fftFct= [handles.fftFct {(2*abs(y(1:nfft/2+1)))}];

    %Store the spectrum a second time to calculate the average spectrum;
    %The avaerage spectrum uses the squareroot of the sum of the squares
    %This method emphasizes the maxima and should help the user to find
    %optimal filter ranges
    handles.fftFctGes = [handles.fftFctGes;transpose(handles.fftFct{x}.^4)];
end

%rescale with the square root
handles.fftFctGes = sqrt(sqrt(sum(handles.fftFctGes)/size(handles.fftFctGes,1)));

%show average spectrum
axes(handles.axes4);
f = handles.infos.rfSamplingFreq/2*linspace(0,1,nfft/2+1);
plot(f,handles.fftFctGes); 
set(gca,'FontUnits','normalized');
xlabel('Frequency (Hz)')
ylabel('sqrt4(\Sigma(|Y(f)|^{ 4})')
title('Single-Sided Amplitude Spectrum (average of all RF lines)');


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes RFProcessing_details wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = RFProcessing_details_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[x y]  = ginput(1);
x = round(x);
if( x>0 && (x <= handles.infos.rfNumberOfScanlines))
    %get a single rf line where the user clicked
    line = handles.infos.images{7}(:,x,1);
    
    %display line
    axes(handles.axes2);
    plot(line, 'b'); 
    set(gca,'FontUnits','normalized');
    axis([0 length(line) min(line) max(line)]); 
    rftitle = sprintf('RF Line: %d', x);
    xlabel('Sample Number')
    ylabel('Amplitude')
    title(rftitle);  
    
    %display frequency spectrum
    axes(handles.axes3);
    f = handles.infos.rfSamplingFreq/2*linspace(0,1,size(handles.fftFct{x},1));
    plot(f,handles.fftFct{x}); 
    set(gca,'FontUnits','normalized');
    rftitle= sprintf('Single-Sided Amplitude Spectrum of RF line %d',x);
    xlabel('Frequency (Hz)')
    ylabel('|Y(f)|')
    title(rftitle);
end
