function varargout = RFProcessing_result(varargin)
% FIGURE_RFProcessing_RESULT M-file for figure_RFProcessing_result.fig
%      FIGURE_RFProcessing_RESULT, by itself, creates a new FIGURE_RFProcessing_RESULT or raises the existing
%      singleton*.
%
%      H = FIGURE_RFProcessing_RESULT returns the handle to a new FIGURE_RFProcessing_RESULT or the handle to
%      the existing singleton*.
%
%      FIGURE_RFProcessing_RESULT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FIGURE_RFProcessing_RESULT.M with the given input arguments.
%
%      FIGURE_RFProcessing_RESULT('Property','Value',...) creates a new FIGURE_RFProcessing_RESULT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before RFProcessing_result_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to RFProcessing_result_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright (c) 2010 
% Andre Dau, Athanasios Karamalis, Christian Wachinger 
% Computer Aided Medical Procedures (CAMP) 
% Technische Universitt Mnchen (TUM) 
% http://campar.in.tum.de/Students/RFtoB 
% All rights reserved.
% 
% Redistribution and use in source and binary forms, with or without
% modification, are permitted provided that the following conditions are met:
%    * Redistributions of source code must retain the above copyright
%       notice, this list of conditions and the following disclaimer.
%    * Redistributions in binary form must reproduce the above copyright
%       notice, this list of conditions and the following disclaimer in the
%       documentation and/or other materials provided with the distribution.
%    * Neither the name of CAMP, TUM nor the
%       names of its contributors may be used to endorse or promote products
%       derived from this software without specific prior written permission.
% 
% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
% ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
% WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
% DISCLAIMED. IN NO EVENT SHALL Andre Dau, Athanasios Karamalis, Christian Wachinger BE LIABLE FOR ANY
% DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
% (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
% LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
% ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
% (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
% SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
% Edit the above text to modify the response to help figure_RFProcessing_result

% Last Modified by GUIDE v2.5 14-Feb-2010 11:05:36

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @RFProcessing_result_OpeningFcn, ...
                   'gui_OutputFcn',  @RFProcessing_result_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before figure_RFProcessing_result is made visible.
function RFProcessing_result_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to figure_RFProcessing_result (see VARARGIN)

% Choose default command line output for figure_RFProcessing_result
handles.output = hObject;

%Saving-Selection-Checkboxes
handles.checkboxes = [handles.checkbox1,handles.checkbox2,handles.checkbox3,handles.checkbox4,handles.checkbox5,handles.checkbox6, handles.checkbox7];

%Cell array of processed images
handles.images = varargin{1};

%Axes to which the images are rendered
handles.axesList = [handles.axes1,handles.axes2,handles.axes3,handles.axes4,handles.axes5,handles.axes6,handles.axes7];
handles.titles = {'1. RF Filtering','2. Envelope Detection','3. Compression','4. Post Processing 1','5. Scan Conversion','6. Post Processing 2','0. Raw RF Image'};

% Geometry of the images in cm
handles.rfWidth = varargin{2};
handles.rfHeight = varargin{3};
handles.rfRatio = varargin{4};

%Calculate the height of the panel where the images are displayed; in cm
% (imageHeight+spacingBetweenImages)*numImages+spacing
handles.panelHeight = (handles.rfHeight+1)*7+4;

%Set the geomtry of the panel
pos_figure = get(hObject,'Position');


set(handles.slider1,'Max',max(pos_figure(4)+1,handles.panelHeight)/pos_figure(4));
set(handles.slider1,'Min',1,'Value',max(pos_figure(4)+1,handles.panelHeight)/pos_figure(4));
set(handles.panel_master,'Position',[0,1-handles.panelHeight/pos_figure(4),1,handles.panelHeight/pos_figure(4)]);
pos_panel = get(handles.panel_master,'Position');
panel_width = pos_panel(3)*pos_figure(3);
panel_height = pos_panel(4)*pos_figure(4);

%Show images
for j=1:7
    
    %raw RF image is stored in cell 7
    if(j==1)
        i = 7;
    else
        i = j-1;
    end
    set(handles.checkboxes(i),'String',handles.titles{i});
    set(handles.axesList(i),'Position',[8/panel_width,((7-j)*handles.rfHeight+(7-j)*1+2)/panel_height,handles.rfWidth/panel_width,handles.rfHeight/panel_height]);
    axes(handles.axesList(i));
    image(handles.images{i},'Parent',handles.axesList(i));
    title(handles.titles(i));
    axis off;
    colormap(gray(256));
end
guidata(gcf, handles);
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes figure_RFProcessing_result wait for user response (see UIRESUME)
% uiwait(handles.figure_RFProcessing_result);


% --- Outputs from this function are returned to the command line.
function varargout = RFProcessing_result_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in checkbox1.
function checkbox1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1


% --- Executes on button press in checkbox2.
function checkbox2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2


% --- Executes on button press in checkbox3.
function checkbox3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox3


% --- Executes on button press in checkbox4.
function checkbox4_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox4


% --- Executes on button press in checkbox5.
function checkbox5_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox5


% --- Executes on button press in checkbox6.
function checkbox6_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox6


% --- Executes on button press in pb_save.
function pb_save_Callback(hObject, eventdata, handles)
% hObject    handle to pb_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
dir = uigetdir ('~/','Choose Directory');
if(dir~=0)
    for i = 1:7
        if(get(handles.checkboxes(i),'Value')~=0)
            
            resx = size(handles.images{i},2)/handles.rfWidth*100;
            resy = size(handles.images{i},1)/handles.rfHeight*100;
            imwrite(ind2rgb(min(256,max(1,round(handles.images{i}))),colormap(gray(256))),fullfile(dir,strcat('rf_processing_',lower(regexprep(handles.titles{i},'[.\s]+','_')),'.png')),'png', 'ResolutionUnit', 'meter','XResolution', resx, 'YResolution', resy);
        end
    end
end

% --- Executes on button press in pb_select.
function pb_select_Callback(hObject, eventdata, handles)
% hObject    handle to pb_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
for checkbox = handles.checkboxes
    set(checkbox,'Value',1);
end
% --- Executes on button press in pb_deselect.
function pb_deselect_Callback(hObject, eventdata, handles)
% hObject    handle to pb_deselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
for checkbox = handles.checkboxes
    set(checkbox,'Value',0);
end


% --- Executes on button press in checkbox1.
function checkbox7_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox1


% --- Executes on button press in checkbox2.
function checkbox8_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox2


% --- Executes on button press in checkbox3.
function checkbox9_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox3


% --- Executes on button press in checkbox4.
function checkbox10_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox4


% --- Executes on button press in checkbox5.
function checkbox11_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox5


% --- Executes on button press in checkbox6.
function checkbox12_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox6


% --- Executes on button press in pb_save.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pb_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pb_select.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pb_select (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pb_deselect.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pb_deselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
panel_pos = get(handles.panel_master,'Position');
set(handles.panel_master,'Position',[panel_pos(1),(1-get(handles.slider1,'Value')),panel_pos(3:4)]);

% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on scroll wheel click while the figure is in focus.
function figure_RFProcessing_result_WindowScrollWheelFcn(hObject, eventdata, handles)
% hObject    handle to figure_RFProcessing_result (see GCBO)
% eventdata  structure with the following fields (see FIGURE)
%	VerticalScrollCount: signed integer indicating direction and number of clicks
%	VerticalScrollAmount: number of lines scrolled for each click
% handles    structure with handles and user data (see GUIDATA)
val = get(handles.slider1,'Value');
set(handles.slider1,'Value',max(get(handles.slider1,'Min'),min(get(handles.slider1,'Max'),val-eventdata.VerticalScrollCount*eventdata.VerticalScrollAmount*0.01)));
panel_pos = get(handles.panel_master,'Position');
set(handles.panel_master,'Position',[panel_pos(1),(1-get(handles.slider1,'Value')),panel_pos(3:4)]);


% --- Executes when figure_RFProcessing_result is resized.
function figure_RFProcessing_result_ResizeFcn(hObject, eventdata, handles)
% hObject    handle to figure_RFProcessing_result (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if isfield(handles,'rfHeight')
handles.panelHeight = (handles.rfHeight+1)*7+4;
pos_figure = get(hObject,'Position');
set(handles.panel_master,'Position',[0,1-handles.panelHeight/pos_figure(4),1,handles.panelHeight/pos_figure(4)]);
pos_panel = get(handles.panel_master,'Position');
panel_width = pos_panel(3)*pos_figure(3);
panel_height = pos_panel(4)*pos_figure(4);
for j=1:7
    
    %raw RF image is stored in cell 7
    if(j==1)
        i = 7;
    else
        i = j-1;
    end
    pos = get(handles.axesList(i),'Position');
    set(handles.axesList(i),'Position',[pos(1:2),handles.rfWidth/panel_width,handles.rfHeight/panel_height]);
    axes(handles.axesList(i));
    image(handles.images{i},'Parent',handles.axesList(i));
    title(handles.titles(i));
    axis off;
    colormap(gray(256));
end
set(handles.slider1,'Max',max(pos_figure(4)+1,handles.panelHeight)/pos_figure(4));
set(handles.slider1,'Min',1,'Value',max(pos_figure(4)+1,handles.panelHeight)/pos_figure(4));
end
