function [ processedImage,filterFct ] = fir_parks_mcclellan_procFilter( rfImage,argString,handles )
%FIR_PARK_MCCLELLAN_PROCFILTER Summary of this function goes here
%   Detailed explanation goes here

    [stop_low,rest] = strtok(argString,',');
    stop_low =1000*str2double(stop_low);
    
    [pass_min,rest] = strtok(rest,',');
    pass_min = 1000*str2double(pass_min);
    
    [pass_max,rest] = strtok(rest,',');
    pass_max = 1000*str2double(pass_max);
    
    [stop_high,rest] = strtok(rest,',');
    stop_high = 1000*str2double(stop_high);
    
    [att_stop_low,rest] = strtok(rest,',');
    att_stop_low = str2double(att_stop_low);
    att_stop_low = 10^(att_stop_low/-20);
    
    [att_stop_high,rest] = strtok(rest,',');
    att_stop_high = str2double(att_stop_high);  
    att_stop_high = 10^(att_stop_high/-20);
    
    [pass_ripple,rest] = strtok(rest,',');
    pass_ripple = str2double(pass_ripple);
    pass_ripple = 10^(pass_ripple/-20);
    pass_ripple = (1-pass_ripple)/(1+pass_ripple);
    
    density = strtok(rest,',' );
    density = str2double(density);  
    
    if(stop_low>handles.rfSamplingFreq/2 || pass_min>handles.rfSamplingFreq/2 || pass_max>handles.rfSamplingFreq/2 || stop_high>handles.rfSamplingFreq/2)
        error(strcat('Maximale Frequenzhoehe: ',num2str(handles.rfSamplingFreq/2)));
    end
       
    f = [stop_low pass_min pass_max stop_high];
    a = [0 1 0];
    dev = [att_stop_low pass_ripple att_stop_high];

	% estimate filter parameters
    [n,fo,ao,w] = firpmord(f,a,dev,handles.rfSamplingFreq);

	% filter should have even order to prevent unnecessary forced roots  and to obtain
	% and to make phase shift calculation easier

    if((bitand(n,1) == 1))
		n = n+1;
    end

    filterFct = firpm(n,fo,ao,w,{density});

    %n/2 is the phase shift
    processedImage = filter(dfilt.dffir(filterFct),[rfImage;zeros(n/2,size(rfImage,2))]);
    processedImage = processedImage((n/2+1):end,:);
end


